#include<bits/stdc++.h>
using namespace std;
int n,M,k;
vector<int>con[100000];
vector<int>revcon[100000];
int m[100000];
int arr[100000];
bool grad[50000];
void dfs(int a)
{
    bool checked[50000]={0};
    queue<int> p;
    p.push(a);
    while(!p.empty())
    {
        for(auto s:con[p.front()])
    {
        if(checked[s])continue;
        checked[s]=true;
        p.push(s);
    }
    p.pop();
    }
    for(int i=1;i<=n;i++)
    {
        grad[i]=grad[i]&&checked[i];
    }
}
void revdfs(int a)
{
    bool checked[50000]={0};
    queue<int> p;
    p.push(a);
    while(!p.empty())
    {
        for(auto s:revcon[p.front()])
    {
        if(checked[s])continue;
        checked[s]=true;
        p.push(s);
    }
    p.pop();
    }
    for(int i=1;i<=n;i++)
    {
        grad[i]=grad[i]&&checked[i];
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>M>>k;
    for(int i=0;i<M;i++)
    {
        int a,b;
        cin>>a>>b;
        con[a].push_back(b);
        revcon[b].push_back(a);
    }
    for(int i=1;i<=n;i++)
    {
        grad[i]=1;
    }
    for(int i=0;i<k;i++)
    {
        int a,b;
        cin>>a>>b;
        dfs(a);
        revdfs(b);
    }
    int br=0;
    for(int i=1;i<=n;i++)
    {
        if(grad[i])
        {
            br++;
        }
    }
    cout<<br<<endl;
    for(int i=1;i<=n;i++)
    {
        if(grad[i])
        {
            cout<<i<<" ";
        }
    }
    return 0;
}
